import React, { DragEventHandler, MouseEventHandler } from 'react';
import { EChartsOption, GeoOption, GridOption, LegendComponentOption, SeriesOption, TooltipOption, XAXisOption, YAXisOption } from 'echarts/types/dist/shared';
import SmECharts from './index';
export declare type MouseEvents<T extends HTMLElement> = {
    onClick?: MouseEventHandler<T>;
    onClickCapture?: MouseEventHandler<T>;
    onContextMenu?: MouseEventHandler<T>;
    onContextMenuCapture?: MouseEventHandler<T>;
    onDoubleClick?: MouseEventHandler<T>;
    onDoubleClickCapture?: MouseEventHandler<T>;
    onDrag?: DragEventHandler<T>;
    onDragCapture?: DragEventHandler<T>;
    onDragEnd?: DragEventHandler<T>;
    onDragEndCapture?: DragEventHandler<T>;
    onDragEnter?: DragEventHandler<T>;
    onDragEnterCapture?: DragEventHandler<T>;
    onDragExit?: DragEventHandler<T>;
    onDragExitCapture?: DragEventHandler<T>;
    onDragLeave?: DragEventHandler<T>;
    onDragLeaveCapture?: DragEventHandler<T>;
    onDragOver?: DragEventHandler<T>;
    onDragOverCapture?: DragEventHandler<T>;
    onDragStart?: DragEventHandler<T>;
    onDragStartCapture?: DragEventHandler<T>;
    onDrop?: DragEventHandler<T>;
    onDropCapture?: DragEventHandler<T>;
    onMouseDown?: MouseEventHandler<T>;
    onMouseDownCapture?: MouseEventHandler<T>;
    onMouseEnter?: MouseEventHandler<T>;
    onMouseLeave?: MouseEventHandler<T>;
    onMouseMove?: MouseEventHandler<T>;
    onMouseMoveCapture?: MouseEventHandler<T>;
    onMouseOut?: MouseEventHandler<T>;
    onMouseOutCapture?: MouseEventHandler<T>;
    onMouseOver?: MouseEventHandler<T>;
    onMouseOverCapture?: MouseEventHandler<T>;
    onMouseUp?: MouseEventHandler<T>;
    onMouseUpCapture?: MouseEventHandler<T>;
};
export declare type ChartType = SeriesOption['type'];
export declare type SmEChartsOption = {
    /**
     * @deprecated
     */
    legend?: LegendComponentOption | LegendComponentOption[];
    /**
     * @deprecated
     */
    grid?: GridOption | GridOption[];
    /**
     * @deprecated
     */
    xAxis?: XAXisOption | XAXisOption[];
    /**
     * @deprecated
     */
    yAxis?: YAXisOption | YAXisOption[];
    /**
     * @deprecated
     */
    geo?: GeoOption | GeoOption[];
    /**
     * @deprecated
     */
    series?: SeriesOption | SeriesOption[];
    /**
     * @deprecated
     */
    tooltip?: TooltipOption | TooltipOption[];
} & Omit<EChartsOption, 'legend' | 'grid' | 'xAxis' | 'yAxis' | 'geo' | 'series' | 'tooltip'>;
export declare type EventHandler = ((arg: any) => void) | [string | Record<string, any>, (arg: any) => void];
export declare type SmEChartsProps = {
    className?: string;
    style?: React.CSSProperties;
    notMerge?: boolean;
    lazyUpdate?: boolean;
    option?: SmEChartsOption;
    legend?: LegendComponentOption | LegendComponentOption[];
    grid?: GridOption | GridOption[];
    xAxis?: XAXisOption | XAXisOption[];
    yAxis?: YAXisOption | YAXisOption[];
    geo?: GeoOption | GeoOption[];
    series?: SeriesOption | SeriesOption[];
    tooltip?: TooltipOption | TooltipOption[];
    type?: ChartType | ChartType[];
    category?: any[];
    data?: any[];
    multi?: boolean;
    rotateAxis?: boolean;
    debug?: boolean;
    onEvents?: Record<string, EventHandler | EventHandler[]>;
    onInit?: (instance: SmECharts) => void;
    beforeSetOption?: (instance: SmECharts) => void;
    afterSetOption?: (instance: SmECharts) => void;
    onDestroy?: (instance: SmECharts) => void;
} & MouseEvents<HTMLDivElement>;
